﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class GameGUI : LittleMissBehaviour {
	#region INSPECTOR
	public Text[] scoreText;
	public Text winnerText;
	public Image winnerImage;
	public CanvasGroup buttonsGroup;
	#endregion

	public static GameGUI Instance { get; private set; }

	void Awake() {
		// First we check if there are any other instances conflicting
		if ( Instance != null && Instance != this ) {
			//destroy the new instance
			Destroy( this );
			return;
		}
		// Here we save our singleton instance
		Instance = this;

		Init();
	}

	void Init() {
		
	}

	public void ShowButtons() {
		LeanTween.alphaCanvas(buttonsGroup, 1f, 2f);
	}

	public void MenuButton() {
		//temp
		GameState.Instance.RestartLevel();
	}


	public void SetScore( PlayerNum playerNum, int score ) {
		scoreText[(int)playerNum].text = score.ToString();
    }

	public void DeclareWinner( PlayerWorm playerWorm ) {
		//winnerText.enabled = true;
		winnerImage.gameObject.SetActive(true);
	}
}
