﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HomeBase : LittleMissBehaviour
{
	const float spriteMaskStartY = 0.048f;
	const float spriteMaskEndY = 1.06f;

	public PlayerNum owner;
	public Transform spriteMaskTransform;
	public int totalFoodChunks = 0;

	private void OnTriggerEnter2D(Collider2D collision) {
		var segment = collision.GetComponent<WormSegment>();
        if (segment != null && segment.worm.playerNum == owner) {
			int numFoodChunks = segment.worm.EmptyOutFoodChunks();
			if ( numFoodChunks > 0 ) {
				StartCoroutine(FillUp(numFoodChunks, segment.worm));
			}
			
		}
	}

	IEnumerator FillUp( int numFoodChunks, PlayerWorm worm ) {
		totalFoodChunks += numFoodChunks;
		float yPos = spriteMaskStartY + (spriteMaskEndY-spriteMaskStartY) * (float)totalFoodChunks / GameState.Instance.foodChunksToWin;
		LeanTween.moveLocalY(spriteMaskTransform.gameObject, yPos, 1f).setEase(LeanTweenType.easeInOutSine);

		worm.PlayFillGaugeClip();

		if (totalFoodChunks >= GameState.Instance.foodChunksToWin) {
			yield return new WaitForSeconds(1f);
			GameState.Instance.Win(worm);
		}
	}
}
