﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LevelState : LittleMissBehaviour
{
    static int levelIndex = 0;
    public Transform[] levelPrefabs;


	public static LevelState Instance { get; private set; }

	void Awake() {
		// First we check if there are any other instances conflicting
		if (Instance != null && Instance != this) {
			//destroy the new instance
			Destroy(this);
			return;
		}
		// Here we save our singleton instance
		Instance = this;

		Init();
	}

	void Init() {
		//var level = levelPrefabs[Random.Range(0, levelPrefabs.Length - 1)].Spawn();
		var level = levelPrefabs[levelIndex].Spawn();
		level.parent = transform;
		levelIndex = (levelIndex + 1) % levelPrefabs.Length;
	}
}
