﻿using UnityEngine;
using System.Collections;

public class Rotator : MonoBehaviour {
	//TODO - constrain
	public Vector3 axis;
	public Vector3 pivot;
	public bool local = true;
	public float revolutionTime = 5f;
	private bool paused = false;

	private float defaultRevolutionTime;
	private bool hasSlowed = false, canBeSlowed = true, resetSlow = false;
	

	// Use this for initialization
	void Start () {
		defaultRevolutionTime = revolutionTime;
	}
	
	// Update is called once per frame
	void Update () {
		if ( paused ) {
			return;
		}
		Vector3 pos = local ? transform.position + pivot : pivot;
		transform.RotateAround( pos, axis, 360f * Time.deltaTime / revolutionTime );
	}

	public void Pause() {
		paused = true;
	}

	public void Unpause() {
		paused = false;
	}

	protected virtual void LateUpdate() {
		if ( resetSlow ) {
			Unslow();
		}
		resetSlow = true;
	}

	public void Slow( float rate ) {
		if ( !canBeSlowed ) {
			return;
		}
		resetSlow = false;
		if ( !hasSlowed ) {
			revolutionTime = defaultRevolutionTime / rate;
		}
		hasSlowed = true;
	}

	public void Unslow() {
		if ( !canBeSlowed ) {
			return;
		}
		if ( hasSlowed ) {
			revolutionTime = defaultRevolutionTime;
		}
		hasSlowed = false;
	}
}
