﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public enum VeggieTypes { RADISH=0, CARROT, ONION }

public class Veggie : LittleMissBehaviour
{
    const int MAX_BITES = 400;

    public Color foodColor;
    public SpriteMask wormBitePrefab;

    int bites = 0;

    private void Awake() {
        wormBitePrefab.CreatePool(MAX_BITES);
    }

    void OnTriggerStay2D(Collider2D collision) {
        //HACK to reduce bite frequency
        if ( Time.frameCount % 4 != 0 ) {
            return;
        }
        var segment = collision.GetComponent<WormSegment>();
        if (segment.worm.IsHead(segment) || segment.worm.IsTail(segment)) {
            segment.worm.SetVeggie(this);
            if (segment.worm.IsHead(segment) && segment.worm.CanEat()) {
                Vector2 offset = (Vector2)segment.transform.up * .1f + new Vector2(Random.Range(-.1f, .1f), Random.Range(-.1f, .1f));
                if (bites < MAX_BITES ) {
                    var bite = wormBitePrefab.Spawn(segment.transform.position + (Vector3)offset);
                    bite.transform.parent = transform;
                    bites++;
                }
                segment.worm.Eat();
            }
        }
    }
}
